## Weak and strong normalization proofs in Lean

# Autosubst
fintype.lean: Finite types, composition and cons (definitions and equational reasoning). Included in Autosubst.

utlc_num.lean: STLC(with constants and addition), instantiation operation (definitions and equational reasoning). Generated by Autosubst. Contains a tactic `arw` for simplification of substitution expressions.

# Weak Normalization 
step_cbv: Call-by-value reduction, big-step semantics, typing relation. 
wn.lean: Semantic typing with logical relations, compatibility, soundness and weak normalization of cbn-step.

# Strong Normalization
step: Reduction, big-step semantics, typing relation. Substitutivity and Morphism.
sn_predicate: Accessibility predicate SN.
reducibility_sn: Reducibility relation R, soundness and strong normalization.

# Tactics
tactics.lean: Some additional tactics, for example `aauto` which tries to solve a subgoal by applying hypotheses in the context.
wftactic.lean: Approach to support well-founded structural recursion (tactic suggested by Sebastian Ullrich)