Require Export fintype.

Inductive nat ( : nat) : Type :=
  .

Fixpoint ren_nat {  : nat } {  : nat } (s : nat ) : _ :=
    match s with
    
    end.

Fixpoint subst_nat {  : nat } {  : nat } (s : nat ) : _ :=
    match s with
    
    end.

Fixpoint idSubst_nat {  : nat } (s : nat ) : subst_nat s = s :=
    match s with
    
    end.

Fixpoint extRen_nat {  : nat } {  : nat } (s : nat ) : ren_nat s = ren_nat s :=
    match s with
    
    end.

Fixpoint ext_nat {  : nat } {  : nat } (s : nat ) : subst_nat s = subst_nat s :=
    match s with
    
    end.

Fixpoint compRenRen_nat {  : nat } {  : nat } {  : nat } (s : nat ) : ren_nat (ren_nat s) = ren_nat s :=
    match s with
    
    end.

Fixpoint compRenSubst_nat {  : nat } {  : nat } {  : nat } (s : nat ) : subst_nat (ren_nat s) = subst_nat s :=
    match s with
    
    end.

Fixpoint compSubstRen_nat {  : nat } {  : nat } {  : nat } (s : nat ) : ren_nat (subst_nat s) = subst_nat s :=
    match s with
    
    end.

Fixpoint compSubstSubst_nat {  : nat } {  : nat } {  : nat } (s : nat ) : subst_nat (subst_nat s) = subst_nat s :=
    match s with
    
    end.

Fixpoint rinst_inst_nat {  : nat } {  : nat } (s : nat ) : ren_nat s = subst_nat s :=
    match s with
    
    end.

Inductive tm (ntm : nat) : Type :=
  | var_tm  : fin ntm -> tm ntm
  | app  : tm ntm -> tm ntm -> tm ntm
  | lam  : tm (S ntm) -> tm ntm
  | const  : nat  -> tm ntm
  | plus  : tm ntm -> tm ntm -> tm ntm.

Lemma congr_app { mtm : nat } { s0 : tm mtm } { s1 : tm mtm } { t0 : tm mtm } { t1 : tm mtm } : s0 = t0 -> s1 = t1 -> app mtm s0 s1 = app mtm t0 t1 .
Proof. congruence. Qed.

Lemma congr_lam { mtm : nat } { s0 : tm (S mtm) } { t0 : tm (S mtm) } : s0 = t0 -> lam mtm s0 = lam mtm t0 .
Proof. congruence. Qed.

Lemma congr_const { mtm : nat } { s0 : nat  } { t0 : nat  } : s0 = t0 -> const mtm s0 = const mtm t0 .
Proof. congruence. Qed.

Lemma congr_plus { mtm : nat } { s0 : tm mtm } { s1 : tm mtm } { t0 : tm mtm } { t1 : tm mtm } : s0 = t0 -> s1 = t1 -> plus mtm s0 s1 = plus mtm t0 t1 .
Proof. congruence. Qed.

Definition upRen_tm_tm { m } { n } (xi : fin m -> fin n) : _ :=
  up_ren xi.

Fixpoint ren_tm { mtm : nat } { ntm : nat } (xitm : fin mtm -> fin ntm) (s : tm mtm) : _ :=
    match s with
    | var_tm s => (var_tm ntm) (xitm s)
    | app s0 s1 => app ntm (ren_tm xitm s0) (ren_tm xitm s1)
    | lam s0 => lam ntm (ren_tm (upRen_tm_tm xitm) s0)
    | const s0 => const ntm (ren_nat  s0)
    | plus s0 s1 => plus ntm (ren_tm xitm s0) (ren_tm xitm s1)
    end.

Definition up_tm_tm { m } { ntm : nat } (sigma : fin m -> tm ntm) : _ :=
  scons ((var_tm (S ntm)) var_zero) (comp tt (ren_tm shift) sigma).

Fixpoint subst_tm { mtm : nat } { ntm : nat } (sigmatm : fin mtm -> tm ntm) (s : tm mtm) : _ :=
    match s with
    | var_tm s => sigmatm s
    | app s0 s1 => app ntm (subst_tm sigmatm s0) (subst_tm sigmatm s1)
    | lam s0 => lam ntm (subst_tm (up_tm_tm sigmatm) s0)
    | const s0 => const ntm (subst_nat  s0)
    | plus s0 s1 => plus ntm (subst_tm sigmatm s0) (subst_tm sigmatm s1)
    end.

Definition upId_tm_tm { mtm : nat } (sigma : fin mtm -> tm mtm) (Eq : forall x, sigma x = (var_tm mtm) x) : forall x, (up_tm_tm sigma) x = (var_tm (S mtm)) x :=
  fun n => match n with
  | Some n => ap (ren_tm shift) (Eq n)
  | None => eq_refl
  end.

Fixpoint idSubst_tm { mtm : nat } (sigmatm : fin mtm -> tm mtm) (Eqtm : forall x, sigmatm x = (var_tm mtm) x) (s : tm mtm) : subst_tm sigmatm s = s :=
    match s with
    | var_tm s => Eqtm s
    | app s0 s1 => congr_app (idSubst_tm sigmatm Eqtm s0) (idSubst_tm sigmatm Eqtm s1)
    | lam s0 => congr_lam (idSubst_tm (up_tm_tm sigmatm) (upId_tm_tm (_) Eqtm) s0)
    | const s0 => congr_const (idSubst_nat   s0)
    | plus s0 s1 => congr_plus (idSubst_tm sigmatm Eqtm s0) (idSubst_tm sigmatm Eqtm s1)
    end.

Definition upExtRen_tm_tm { m } { n } (xi : fin m -> fin n) (zeta : fin m -> fin n) (Eq : forall x, xi x = zeta x) : forall x, (upRen_tm_tm xi) x = (upRen_tm_tm zeta) x :=
  fun n => match n with
  | Some n => ap shift (Eq n)
  | None => eq_refl
  end.

Fixpoint extRen_tm { mtm : nat } { ntm : nat } (xitm : fin mtm -> fin ntm) (zetatm : fin mtm -> fin ntm) (Eqtm : forall x, xitm x = zetatm x) (s : tm mtm) : ren_tm xitm s = ren_tm zetatm s :=
    match s with
    | var_tm s => ap (var_tm ntm) (Eqtm s)
    | app s0 s1 => congr_app (extRen_tm xitm zetatm Eqtm s0) (extRen_tm xitm zetatm Eqtm s1)
    | lam s0 => congr_lam (extRen_tm (upRen_tm_tm xitm) (upRen_tm_tm zetatm) (upExtRen_tm_tm xitm zetatm Eqtm) s0)
    | const s0 => congr_const (extRen_nat    s0)
    | plus s0 s1 => congr_plus (extRen_tm xitm zetatm Eqtm s0) (extRen_tm xitm zetatm Eqtm s1)
    end.

Definition upExt_tm_tm { m } { ntm : nat } (sigma : fin m -> tm ntm) (tau : fin m -> tm ntm) (Eq : forall x, sigma x = tau x) : forall x, (up_tm_tm sigma) x = (up_tm_tm tau) x :=
  fun n => match n with
  | Some n => ap (ren_tm shift) (Eq n)
  | None => eq_refl
  end.

Fixpoint ext_tm { mtm : nat } { ntm : nat } (sigmatm : fin mtm -> tm ntm) (tautm : fin mtm -> tm ntm) (Eqtm : forall x, sigmatm x = tautm x) (s : tm mtm) : subst_tm sigmatm s = subst_tm tautm s :=
    match s with
    | var_tm s => Eqtm s
    | app s0 s1 => congr_app (ext_tm sigmatm tautm Eqtm s0) (ext_tm sigmatm tautm Eqtm s1)
    | lam s0 => congr_lam (ext_tm (up_tm_tm sigmatm) (up_tm_tm tautm) (upExt_tm_tm sigmatm tautm Eqtm) s0)
    | const s0 => congr_const (ext_nat    s0)
    | plus s0 s1 => congr_plus (ext_tm sigmatm tautm Eqtm s0) (ext_tm sigmatm tautm Eqtm s1)
    end.

Fixpoint compRenRen_tm { ktm : nat } { ltm : nat } { mtm : nat } (xitm : fin mtm -> fin ktm) (zetatm : fin ktm -> fin ltm) (rhotm : fin mtm -> fin ltm) (Eqtm : forall x, (comp tt zetatm xitm) x = rhotm x) (s : tm mtm) : ren_tm zetatm (ren_tm xitm s) = ren_tm rhotm s :=
    match s with
    | var_tm s => ap (var_tm ltm) (Eqtm s)
    | app s0 s1 => congr_app (compRenRen_tm xitm zetatm rhotm Eqtm s0) (compRenRen_tm xitm zetatm rhotm Eqtm s1)
    | lam s0 => congr_lam (compRenRen_tm (upRen_tm_tm xitm) (upRen_tm_tm zetatm) (upRen_tm_tm rhotm) (up_ren_ren xitm zetatm rhotm Eqtm) s0)
    | const s0 => congr_const (compRenRen_nat     s0)
    | plus s0 s1 => congr_plus (compRenRen_tm xitm zetatm rhotm Eqtm s0) (compRenRen_tm xitm zetatm rhotm Eqtm s1)
    end.

Definition up_ren_subst_tm_tm { k } { l } { mtm : nat } (xi : fin k -> fin l) (tau : fin l -> tm mtm) (theta : fin k -> tm mtm) (Eq : forall x, (comp tt tau xi) x = theta x) : forall x, (comp tt (up_tm_tm tau) (upRen_tm_tm xi)) x = (up_tm_tm theta) x :=
  fun n => match n with
  | Some n => ap (ren_tm shift) (Eq n)
  | None => eq_refl
  end.

Fixpoint compRenSubst_tm { ktm : nat } { ltm : nat } { mtm : nat } (xitm : fin mtm -> fin ktm) (tautm : fin ktm -> tm ltm) (thetatm : fin mtm -> tm ltm) (Eqtm : forall x, (comp tt tautm xitm) x = thetatm x) (s : tm mtm) : subst_tm tautm (ren_tm xitm s) = subst_tm thetatm s :=
    match s with
    | var_tm s => Eqtm s
    | app s0 s1 => congr_app (compRenSubst_tm xitm tautm thetatm Eqtm s0) (compRenSubst_tm xitm tautm thetatm Eqtm s1)
    | lam s0 => congr_lam (compRenSubst_tm (upRen_tm_tm xitm) (up_tm_tm tautm) (up_tm_tm thetatm) (up_ren_subst_tm_tm xitm tautm thetatm Eqtm) s0)
    | const s0 => congr_const (compRenSubst_nat     s0)
    | plus s0 s1 => congr_plus (compRenSubst_tm xitm tautm thetatm Eqtm s0) (compRenSubst_tm xitm tautm thetatm Eqtm s1)
    end.

Definition up_subst_ren_tm_tm { k } { ltm : nat } { mtm : nat } (sigma : fin k -> tm ltm) (zetatm : fin ltm -> fin mtm) (theta : fin k -> tm mtm) (Eq : forall x, (comp tt (ren_tm zetatm) sigma) x = theta x) : forall x, (comp tt (ren_tm (upRen_tm_tm zetatm)) (up_tm_tm sigma)) x = (up_tm_tm theta) x :=
  fun n => match n with
  | Some n => eq_trans (compRenRen_tm shift (upRen_tm_tm zetatm) (comp tt shift zetatm) (fun x => eq_refl) (sigma n)) (eq_trans (eq_sym (compRenRen_tm zetatm shift (comp tt shift zetatm) (fun x => eq_refl) (sigma n))) (ap (ren_tm shift) (Eq n)))
  | None => eq_refl
  end.

Fixpoint compSubstRen_tm { ktm : nat } { ltm : nat } { mtm : nat } (sigmatm : fin mtm -> tm ktm) (zetatm : fin ktm -> fin ltm) (thetatm : fin mtm -> tm ltm) (Eqtm : forall x, (comp tt (ren_tm zetatm) sigmatm) x = thetatm x) (s : tm mtm) : ren_tm zetatm (subst_tm sigmatm s) = subst_tm thetatm s :=
    match s with
    | var_tm s => Eqtm s
    | app s0 s1 => congr_app (compSubstRen_tm sigmatm zetatm thetatm Eqtm s0) (compSubstRen_tm sigmatm zetatm thetatm Eqtm s1)
    | lam s0 => congr_lam (compSubstRen_tm (up_tm_tm sigmatm) (upRen_tm_tm zetatm) (up_tm_tm thetatm) (up_subst_ren_tm_tm sigmatm zetatm thetatm Eqtm) s0)
    | const s0 => congr_const (compSubstRen_nat     s0)
    | plus s0 s1 => congr_plus (compSubstRen_tm sigmatm zetatm thetatm Eqtm s0) (compSubstRen_tm sigmatm zetatm thetatm Eqtm s1)
    end.

Definition up_subst_subst_tm_tm { k } { ltm : nat } { mtm : nat } (sigma : fin k -> tm ltm) (tautm : fin ltm -> tm mtm) (theta : fin k -> tm mtm) (Eq : forall x, (comp tt (subst_tm tautm) sigma) x = theta x) : forall x, (comp tt (subst_tm (up_tm_tm tautm)) (up_tm_tm sigma)) x = (up_tm_tm theta) x :=
  fun n => match n with
  | Some n => eq_trans (compRenSubst_tm shift (up_tm_tm tautm) (comp tt (up_tm_tm tautm) shift) (fun x => eq_refl) (sigma n)) (eq_trans (eq_sym (compSubstRen_tm tautm shift (comp tt (ren_tm shift) tautm) (fun x => eq_refl) (sigma n))) (ap (ren_tm shift) (Eq n)))
  | None => eq_refl
  end.

Fixpoint compSubstSubst_tm { ktm : nat } { ltm : nat } { mtm : nat } (sigmatm : fin mtm -> tm ktm) (tautm : fin ktm -> tm ltm) (thetatm : fin mtm -> tm ltm) (Eqtm : forall x, (comp tt (subst_tm tautm) sigmatm) x = thetatm x) (s : tm mtm) : subst_tm tautm (subst_tm sigmatm s) = subst_tm thetatm s :=
    match s with
    | var_tm s => Eqtm s
    | app s0 s1 => congr_app (compSubstSubst_tm sigmatm tautm thetatm Eqtm s0) (compSubstSubst_tm sigmatm tautm thetatm Eqtm s1)
    | lam s0 => congr_lam (compSubstSubst_tm (up_tm_tm sigmatm) (up_tm_tm tautm) (up_tm_tm thetatm) (up_subst_subst_tm_tm sigmatm tautm thetatm Eqtm) s0)
    | const s0 => congr_const (compSubstSubst_nat     s0)
    | plus s0 s1 => congr_plus (compSubstSubst_tm sigmatm tautm thetatm Eqtm s0) (compSubstSubst_tm sigmatm tautm thetatm Eqtm s1)
    end.

Definition rinstInst_up_tm_tm { m } { ntm : nat } (xi : fin m -> fin ntm) (sigma : fin m -> tm ntm) (Eq : forall x, (comp tt (var_tm ntm) xi) x = sigma x) : forall x, (comp tt (var_tm (S ntm)) (upRen_tm_tm xi)) x = (up_tm_tm sigma) x :=
  fun n => match n with
  | Some n => ap (ren_tm shift) (Eq n)
  | None => eq_refl
  end.

Fixpoint rinst_inst_tm { mtm : nat } { ntm : nat } (xitm : fin mtm -> fin ntm) (sigmatm : fin mtm -> tm ntm) (Eqtm : forall x, (comp tt (var_tm ntm) xitm) x = sigmatm x) (s : tm mtm) : ren_tm xitm s = subst_tm sigmatm s :=
    match s with
    | var_tm s => Eqtm s
    | app s0 s1 => congr_app (rinst_inst_tm xitm sigmatm Eqtm s0) (rinst_inst_tm xitm sigmatm Eqtm s1)
    | lam s0 => congr_lam (rinst_inst_tm (upRen_tm_tm xitm) (up_tm_tm sigmatm) (rinstInst_up_tm_tm xitm sigmatm Eqtm) s0)
    | const s0 => congr_const (rinst_inst_nat    s0)
    | plus s0 s1 => congr_plus (rinst_inst_tm xitm sigmatm Eqtm s0) (rinst_inst_tm xitm sigmatm Eqtm s1)
    end.
